## ibus-chewing 1.5.1

=== Modules/CMakeLists.txt ===
FILE(GLOB CMAKE_FEDORA_MODULES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "[A-Z]*.cmake")

## Remove Generated Modules
LIST(REMOVE_ITEM CMAKE_FEDORA_MODULES "CTestTestfile.cmake")

LIST(APPEND CMAKE_FEDORA_MODULES cmake_uninstall.cmake.in)
INSTALL(FILES ${CMAKE_FEDORA_MODULES} 
    DESTINATION ${DATA_DIR}/cmake/Modules
    )

=== src/CMakeLists.txt ===
#==================================================================
# Variable definition
#
IF(NOT DEFINED LIB_INSTALL_DIR)
    SET(LIB_INSTALL_DIR "lib${IS_64}")
ENDIF()
SET_COMPILE_ENV(LIB_INSTALL_DIR  "${LIB_INSTALL_DIR}"
    DISPLAY STRING "Chewing library directory")

##== Location of library include files
INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    )

IF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    ADD_DEFINITIONS("-DVERBOSE_LEVEL=DEBUG")
ELSE()
    ADD_DEFINITIONS("-DVERBOSE_LEVEL=MSG")
ENDIF()

SET(IBUS_ENGINE_CHEWING ibus-engine-chewing)
SET(IBUS_SETUP_CHEWING ibus-setup-chewing)

#==================================================================
# Dependencies
#

SET(IBUS_CHEWING_DEPENDENCIES CHEWING GLIB2 GTK2 IBUS X11 XTST)

IF(GCONF2_SUPPORT)
    # Schemas
    INCLUDE(ManageGConf)
    LIST(APPEND IBUS_CHEWING_DEPENDENCIES "GCONF2")
    MANAGE_GCONF_SCHEMAS()
ENDIF()

SET(IBUS_CHEWING_DEPENDENCIES "${IBUS_CHEWING_DEPENDENCIES}"
    CACHE INTERAL "IBUS_CHEWING_DEPENDENCIES"
    )

FOREACH(_d ${IBUS_CHEWING_DEPENDENCIES})
    INCLUDE_DIRECTORIES(${${_d}_INCLUDE_DIRS})
#    STRING_APPEND(CMAKE_C_FLAGS "${${_d}_CFLAGS}" " ")
ENDFOREACH(_d ${IBUS_CHEWING_DEPENDENCIES})


#==================================================================
# Sources
#

##== Gob Generate Start ==
SET(IBUS_CHEWING_ENGINE_SOURCE_INCLUDED_C_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingEngine-signal.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingEngine-input-events.c
    )

SET(GOB2_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}")
MACRO(GOB_GENERATE name gobFile)
    SET(GOB_GENERATED_C_${name} 
	${GOB2_OUTPUT_DIR}/${name}.c)
    SET(GOB_GENERATED_${name} 
	${GOB_GENERATED_C_${name}}
	"${GOB2_OUTPUT_DIR}/${name}.h"
	"${GOB2_OUTPUT_DIR}/${name}-private.h"
	CACHE INTERNAL "GOB_GENERATED_${name}"
	)

    ADD_CUSTOM_COMMAND(OUTPUT ${GOB_GENERATED_${name}}
	COMMAND ${GOB2_EXECUTABLE} "${gobFile}" 
	-o "${GOB2_OUTPUT_DIR}/"
	DEPENDS ${gobFile} ${ARGN}
	)
ENDMACRO(GOB_GENERATE name gobFile)


GOB_GENERATE(ibus-chewing-engine 
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingEngine.gob
    ${IBUS_CHEWING_ENGINE_SOURCE_INCLUDED_C_FILES}
    )
GOB_GENERATE(maker-dialog 
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialog.gob 
    )

ADD_CUSTOM_TARGET(gob2
    DEPENDS ${GOB_GENERATED_ibus-chewing-engine} 
    ${GOB_GENERATED_maker-dialog}
    COMMENT "Preprocess with gob2."
    )


SET_SOURCE_FILES_PROPERTIES(${GOB_GENERATED_ibus-chewing-engine} 
    ${GOB_GENERATED_maker-dialog} PROPERTIES GENERATED true
    )

SET(COMMON_SOURCE_C_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingApplier.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingLookupTable.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingProperties.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusConfigBackend.c
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogBackend.c
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogProperty.c
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogUtil.c
    )

SET(COMMON_SOURCE_FILES
    ${COMMON_SOURCE_C_FILES}
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingLookupTable.h
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingProperties.h
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusConfigBackend.h
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogBackend.h
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogProperty.h
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogPropertySpec.h
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogUtil.h
    ${GOB2_OUTPUT_DIR}/ibus-chewing-engine.h
    CACHE INTERNAL "COMMON_SOURCE_FILES"
    )

FILE(GLOB poFiles RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/../po" "../po/*.po")
STRING(REPLACE ".po" ""  TRANSLATED "${poFiles}")
M_MSG(${M_INFO1} "TRANSLATED=${TRANSLATED}")

#==================================================================
# Schemas
#
SET(BACKEND_SOURCE_FILES "")

IF(GSETTINGS_SUPPORT)
    LIST(APPEND BACKEND_SOURCE_FILES 
	"${CMAKE_SOURCE_DIR}/src/GSettingsBackend.c"
	"${CMAKE_SOURCE_DIR}/src/GSettingsBackend.h"
	)
ENDIF()

IF(GCONF2_SUPPORT)
    LIST(APPEND BACKEND_SOURCE_FILES 
	"${CMAKE_SOURCE_DIR}/src/GConf2Backend.c"
	"${CMAKE_SOURCE_DIR}/src/GConf2Backend.h"
	)
ENDIF(GCONF2_SUPPORT)

SET(BACKEND_SOURCE_FILES "${BACKEND_SOURCE_FILES}" CACHE INTERNAL "Backend source files")

SET(COMMON_LIBRARIES
    ${CHEWING_LIBRARIES}
    ${IBUS_LIBRARIES}
    ${GLIB2_LIBRARIES}
    )

SET(BACKEND_LIBRARIES "")

##== GSettings support==
IF(GSETTINGS_SUPPORT)
    SET(PROJECT_GSCHEMA_XML ${PROJECT_SCHEMA_ID}.gschema.xml
	    CACHE INTERNAL "PROJECT_GSCHEMA_XML")
    SET(GSETTINGS_SCHEMAS_DIR "${DATA_DIR}/glib-2.0/schemas")

    ADD_EXECUTABLE(generate-gsettings-schemas
	${COMMON_SOURCE_FILES}
	${CMAKE_CURRENT_SOURCE_DIR}/GSettingsBackend.c
	${CMAKE_CURRENT_SOURCE_DIR}/GSettingsBackend.h
	${CMAKE_CURRENT_SOURCE_DIR}/generate-gsettings-schemas.c
	)

    TARGET_LINK_LIBRARIES(generate-gsettings-schemas 
	${COMMON_LIBRARIES}
	)

    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_GSCHEMA_XML} 
	DESTINATION "${GSETTINGS_SCHEMAS_DIR}"
	)

    ADD_CUSTOM_TARGET(schemas_gsettings ALL
	COMMAND G_MESSAGES_DEBUG=all "${CMAKE_CURRENT_BINARY_DIR}/generate-gsettings-schemas" -v 5 "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_GSCHEMA_XML}"
	COMMAND G_MESSAGES_DEBUG=all glib-compile-schemas "${CMAKE_CURRENT_BINARY_DIR}"
	COMMENT "Generating gsettings schemas ${PROJECT_GSCHEMA_XML}"
	VERBATIM
	)

    ADD_DEPENDENCIES(schemas_gsettings
	generate-gsettings-schemas
	)

    ADD_CUSTOM_TARGET(install_schemas_gsettings
	COMMAND install "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_GSCHEMA_XML}"  "${GSETTINGS_SCHEMAS_DIR}/${PROJECT_GSCHEMA_XML}"
	COMMAND glib-compile-schemas "${GSETTINGS_SCHEMAS_DIR}"
	COMMENT "install_schemas_gsettings"
	)

    ADD_CUSTOM_TARGET(uninstall_schemas_gsettings
	COMMAND rm -f "${GSETTINGS_SCHEMAS_DIR}/${PROJECT_GSCHEMA_XML}"
	COMMAND glib-compile-schemas "${GSETTINGS_SCHEMAS_DIR}"
	COMMENT "install_schemas_gsettings"
	)
ENDIF()

##== GConf2 support==
IF(GCONF2_SUPPORT)
    SET(PROJECT_SCHEMAS ${PROJECT_NAME}.schemas
	CACHE INTERNAL "PROJECT_SCHEMAS")
    SET(GCONF2_SCHEMAS_DIR "${SYSCONF_DIR}/gconf/schemas")

    SET(BACKEND_LIBRARIES ${GCONF_LIBRARIES})

    ADD_EXECUTABLE(generate-gconf-schemas
	${COMMON_SOURCE_FILES}
	${CMAKE_CURRENT_SOURCE_DIR}/GConf2Backend.c
	${CMAKE_CURRENT_SOURCE_DIR}/GConf2Backend.h
	${CMAKE_CURRENT_SOURCE_DIR}/generate-gconf-schemas.c
	)

    LIST(APPEND COMMON_LIBRARIES ${GCONF2_LIBRARIES})

    TARGET_LINK_LIBRARIES(generate-gconf-schemas 
	${COMMON_LIBRARIES} ${BACKEND_LIBRARIES}
	)

    ## ManageGConf is already handle install

    ADD_CUSTOM_TARGET(schemas_gconf2 ALL
	COMMAND G_MESSAGES_DEBUG=all "${CMAKE_CURRENT_BINARY_DIR}/generate-gconf-schemas" -v 5 -l
	"C;${TRANSLATED}" "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_SCHEMAS}"
	COMMENT "Generating gconf-schemas ${PROJECT_SCHEMAS}"
	VERBATIM
	)

    ADD_DEPENDENCIES(schemas_gconf2
	generate-gconf-schemas
	)

    ADD_DEPENDENCIES(generate-gconf-schemas
	translations
	)

ENDIF()

SET(BACKEND_LIBRARIES "${BACKEND_LIBRARIES}" CACHE INTERNAL "Backend Libraries")

#==================================================================
# Executables
#

SET(GUI_CORE_SOURCE_FILES ${COMMON_SOURCE_FILES}
    ${BACKEND_SOURCE_FILES}
    ${GOB_GENERATED_maker-dialog} 
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusConfigBackend.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusConfigBackend.h
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogWidget.c
    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogWidget.h
    CACHE INTERNAL "GUI core source files"
    )


IF(GSETTINGS_SUPPORT)
    LIST(APPEND GUI_CORE_SOURCE_FILES 
	${CMAKE_CURRENT_SOURCE_DIR}/GSettingsBackend.c
	${CMAKE_CURRENT_SOURCE_DIR}/GSettingsBackend.h
	)
ENDIF()

IF(GCONF2_SUPPORT)
    LIST(APPEND GUI_CORE_SOURCE_FILES 
	${CMAKE_CURRENT_SOURCE_DIR}/GConf2Backend.c
	${CMAKE_CURRENT_SOURCE_DIR}/GConf2Backend.h
	)
ENDIF()

##== ibus-setup-chewing Start ==
ADD_EXECUTABLE(${IBUS_SETUP_CHEWING}
    ${GUI_CORE_SOURCE_FILES}
    ${CMAKE_CURRENT_SOURCE_DIR}/ibus-setup-chewing.c
    )

TARGET_LINK_LIBRARIES(${IBUS_SETUP_CHEWING}
    ${COMMON_LIBRARIES}
    ${GTK2_LIBRARIES}
    )

MANAGE_FILE_INSTALL(TARGETS ${IBUS_SETUP_CHEWING} ARGS
    LIBEXEC DESTINATION ${LIBEXEC_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    )

##== ibus-engine-chewing Start ==
SET(IBUS_ENGINE_CHEWING_LIBRARIES ${COMMON_LIBRARIES} 
    ${GTK2_LIBRARIES}
    ${X11_LIBRARIES}
    ${XTST_LIBRARIES} 
    CACHE INTERNAL "IBUS_ENGINE_CHEWING_LIBRARIES"
    )

ADD_EXECUTABLE(${IBUS_ENGINE_CHEWING}
    ${GUI_CORE_SOURCE_FILES}
    ${GOB_GENERATED_ibus-chewing-engine}
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingLookupTable.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingLookupTable.h
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingPreEdit.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingPreEdit.h
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingSystray.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingSystray.h
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingUtil.c
    ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingUtil.h
    ${CMAKE_CURRENT_SOURCE_DIR}/main.c
    )

TARGET_LINK_LIBRARIES(${IBUS_ENGINE_CHEWING}
    ${IBUS_ENGINE_CHEWING_LIBRARIES}
    )


MANAGE_FILE_INSTALL(TARGETS ${IBUS_ENGINE_CHEWING} ARGS
    LIBEXEC DESTINATION ${LIBEXEC_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    )

SET(COMMON_LIBRARIES "${COMMON_LIBRARIES}" CACHE INTERNAL "Common Libraries")

=== test/CMakeLists.txt ===
#==================================================================
# Variable definition
#

##== Location of library include files
INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/bin
    )

IF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    ADD_DEFINITIONS("-DVERBOSE_LEVEL=DEBUG")
ELSE()
    ADD_DEFINITIONS("-DVERBOSE_LEVEL=MSG")
ENDIF()

ADD_DEFINITIONS("-DUNIT_TEST=1")

SET_SOURCE_FILES_PROPERTIES(${GOB_GENERATED_ibus-chewing-engine} 
    ${GOB_GENERATED_maker-dialog} PROPERTIES GENERATED true
    )

#==================================================================
# Dependencies
#

FOREACH(_d ${IBUS_CHEWING_DEPENDENCIES})
    INCLUDE_DIRECTORIES(${${_d}_INCLUDE_DIRS})
    LINK_DIRECTORIES(${${_d}_LIBRARY_DIRS})
ENDFOREACH(_d ${IBUS_CHEWING_DEPENDENCIES})

#===========================================
#  MakerDialogUtil
#

SET(MAKER_DIALOG_UTIL MakerDialogUtil)
ADD_EXECUTABLE(${MAKER_DIALOG_UTIL}-test
    ${CMAKE_CURRENT_SOURCE_DIR}/${MAKER_DIALOG_UTIL}-test.c
    ${CMAKE_SOURCE_DIR}/src/${MAKER_DIALOG_UTIL}.c
    )

TARGET_LINK_LIBRARIES(${MAKER_DIALOG_UTIL}-test
    ${GLIB2_LIBRARIES}
    )

ADD_TEST("${MAKER_DIALOG_UTIL}"
    gtester ${CMAKE_CURRENT_BINARY_DIR}/${MAKER_DIALOG_UTIL}-test
    )

#===========================================
#  MakerDialogBackend
#

SET(MAKER_DIALOG_BACKEND MakerDialogBackend)
ADD_EXECUTABLE(${MAKER_DIALOG_BACKEND}-test
    ${COMMON_SOURCE_FILES} ${BACKEND_SOURCE_FILES}
    ${CMAKE_CURRENT_SOURCE_DIR}/${MAKER_DIALOG_BACKEND}-test.c
    ${CMAKE_SOURCE_DIR}/src/MakerDialogBackend.c
    ${CMAKE_SOURCE_DIR}/src/MakerDialogProperty.c
    ${CMAKE_SOURCE_DIR}/src/MakerDialogUtil.c
    )

TARGET_LINK_LIBRARIES(${MAKER_DIALOG_BACKEND}-test
    ${COMMON_LIBRARIES}
    ${BACKEND_LIBRARIES}
    )

ADD_TEST("${MAKER_DIALOG_BACKEND}"
    gtester ${CMAKE_CURRENT_BINARY_DIR}/${MAKER_DIALOG_BACKEND}-test
    )

#===========================================
#  IBusChewingPreEdit
#

SET(IBUS_CHEWING_PRE_EDIT IBusChewingPreEdit)


ADD_EXECUTABLE(${IBUS_CHEWING_PRE_EDIT}-test
    ${COMMON_SOURCE_FILES} ${BACKEND_SOURCE_FILES}
    ${CMAKE_CURRENT_SOURCE_DIR}/${IBUS_CHEWING_PRE_EDIT}-test.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingUtil.c
    ${CMAKE_SOURCE_DIR}/src/${IBUS_CHEWING_PRE_EDIT}.c
    )

TARGET_LINK_LIBRARIES(${IBUS_CHEWING_PRE_EDIT}-test
    ${COMMON_LIBRARIES}
    ${X11_LIBRARIES}
    ${BACKEND_LIBRARIES}
    )

ADD_TEST("${IBUS_CHEWING_PRE_EDIT}"
    gtester ${CMAKE_CURRENT_BINARY_DIR}/${IBUS_CHEWING_PRE_EDIT}-test
    )


#===========================================
#  IBusChewingEngine
#

SET(IBUS_ENGINE_CHEWING ibus-chewing-engine)

ADD_EXECUTABLE(${IBUS_ENGINE_CHEWING}-test
    ${GUI_CORE_SOURCE_FILES}
    ${GOB_GENERATED_ibus-chewing-engine}
    ${CMAKE_SOURCE_DIR}/src/IBusChewingLookupTable.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingLookupTable.h
    ${CMAKE_SOURCE_DIR}/src/IBusChewingPreEdit.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingPreEdit.h
    ${CMAKE_SOURCE_DIR}/src/IBusChewingSystray.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingSystray.h
    ${CMAKE_SOURCE_DIR}/src/IBusChewingUtil.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingUtil.h
    ${CMAKE_CURRENT_SOURCE_DIR}/${IBUS_ENGINE_CHEWING}-test.c
    )

TARGET_LINK_LIBRARIES(${IBUS_ENGINE_CHEWING}-test
    ${IBUS_ENGINE_CHEWING_LIBRARIES}
    ${BACKEND_LIBRARIES}
    )

ADD_TEST("${IBUS_ENGINE_CHEWING}"
    gtester ${CMAKE_CURRENT_BINARY_DIR}/${IBUS_ENGINE_CHEWING}-test
    )

=== debian/changelog ===
ibus-chewing (1.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump compat to 10.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 19 Jun 2016 15:23:52 +0800

ibus-chewing (1.5.0-1) unstable; urgency=medium

  * new upstream release.
  * Bump Standards-Version to 3.9.8.
  * Remove upstream applied patches.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 06 May 2016 23:20:31 +0800

=== debian/control ===
Source: ibus-chewing
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Asias He <asias.hejun@gmail.com>,
           Osamu Aoki <osamu@debian.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends: debhelper (>= 9.20160403),
               cmake,
               cmake-fedora (>= 2.4.4+20151201),
               gob2 (>= 2.0.17),
               pkg-config,
               libchewing3-dev (>= 0.3.2-2~),
               libgconf2-dev,
               libibus-1.0-dev (>= 1.3.99.20110419),
               libgtk2.0-dev,
               libx11-dev,
               libxtst-dev
Standards-Version: 3.9.8
Homepage: https://github.com/definite/ibus-chewing
Vcs-Git: https://anonscm.debian.org/git/pkg-ime/ibus-chewing.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ime/ibus-chewing.git

Package: ibus-chewing
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ibus (>= 1.5),
Description: Chewing engine for IBus
 IBus is an Intelligent Input Bus. It is a new input framework for Linux
 OS. It provides full featured and user friendly input method user interface.
 It also may help developers to develop input method easily.
 .
 IBus-chewing is a IBus based IM Engine for Traditional Chinese

=== debian/watch ===
version=3
opts=uversionmangle=s/-Source$// \
https://github.com/definite/ibus-chewing/releases .*/ibus-chewing(?:-|_|_v|V)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
https://github.com/definite/ibus-chewing/releases .*/([\d\.]*)\.tar.gz

## ibus-chewing 1.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.0)

# Included scripts do automatic cmake_policy PUSH and POP.
# OLD: CMake policy in included script will affect the invoker.
CMAKE_POLICY(SET CMP0011 OLD)
IF(POLICY CMP0065)
    CMAKE_POLICY(SET CMP0065 OLD)
ENDIF()

####################################################################
# Find cmake-fedora
#
LIST(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/Modules")
INCLUDE(ManageEnvironmentCommon OPTIONAL RESULT_VARIABLE MANAGE_ENVIRONMENT_PATH)

IF(MANAGE_ENVIRONMENT_PATH STREQUAL "NOTFOUND")
    # Is cmake-fedora a git submodule?
    IF(NOT EXISTS ${CMAKE_SOURCE_DIR}/Modules)
	## Create a link if Modules/ does not exists
	IF(NOT EXISTS ${CMAKE_SOURCE_DIR}/cmake-fedora)
	    IF(EXISTS ${CMAKE_SOURCE_DIR}/.gitmodules)
                ## cmake-fedora may be a git submodules
		EXECUTE_PROCESS(COMMAND git submodule init
		    COMMAND git submodule update
		    RESULT_VARIABLE gitSubmoduleFailed
		    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		    )
	    ENDIF(EXISTS ${CMAKE_SOURCE_DIR}/.gitmodules)
	ENDIF(NOT EXISTS ${CMAKE_SOURCE_DIR}/cmake-fedora)

	IF(EXISTS ${CMAKE_SOURCE_DIR}/cmake-fedora/Modules)
            ## cmake-fedora is now available as subdirectory, try again
	    EXECUTE_PROCESS(COMMAND ln -s ${CMAKE_SOURCE_DIR}/cmake-fedora/Modules ${CMAKE_SOURCE_DIR}/Modules)
	    INCLUDE(ManageEnvironmentCommon RESULT_VARIABLE MANAGE_ENVIRONMENT_PATH)
	ENDIF(EXISTS ${CMAKE_SOURCE_DIR}/cmake-fedora/Modules)
    ENDIF(NOT EXISTS ${CMAKE_SOURCE_DIR}/Modules)
ENDIF(MANAGE_ENVIRONMENT_PATH STREQUAL "NOTFOUND")

IF(MANAGE_ENVIRONMENT_PATH STREQUAL "NOTFOUND")
    MESSAGE(FATAL_ERROR "ManageEnvironmentCommon.cmake is not found in CMAKE_MODULE_PATH.
Please either:
    1) Use cmake-fedora as a git submodule:
       git submodule add https://git.fedorahosted.org/git/cmake-fedora.git
    2) Install cmake-fedora from repository:
       yum -y install cmake-fedora
    3) Download the source:
       wget https://fedorahosted.org/releases/c/m/cmake-fedora/cmake-fedora-modules-only-latest.tar.gz
       tar zxvf SOURCES/cmake-fedora-modules-only-latest.tar.gz")
ENDIF(MANAGE_ENVIRONMENT_PATH STREQUAL "NOTFOUND")

GET_FILENAME_COMPONENT(CMAKE_FEDORA_MODULE_DIR
    "${MANAGE_ENVIRONMENT_PATH}" PATH CACHE
    )

# Whether to build on fedora
SET(CMAKE_FEDORA_ENABLE_FEDORA_BUILD "0" CACHE STRING "Enable fedora build")

# Default Message level M_OFF (4)
SET(MANAGE_MESSAGE_LEVEL 7 CACHE STRING "Message (Verbose) Level")

####################################################################
# Project specific information
#
PROJECT(ibus-chewing)
SET(PRJ_SUMMARY "The Chewing engine for IBus input platform")
SET(SUMMARY_TRANSLATIONS
    "zh_TW" "IBus新酷音輸入法")

SET(PRJ_DESCRIPTION
"IBus-chewing is an IBus front-end of Chewing, an intelligent Chinese input
method for Zhuyin (BoPoMoFo) users.
It supports various Zhuyin keyboard layout, such as standard (DaChen),
IBM, Gin-Yeah, Eten, Eten 26, Hsu, Dvorak, Dvorak-Hsu, and DaChen26.

Chewing also support toned Hanyu pinyin input.")
SET(DESCRIPTION_TRANSLATIONS
"zh_TW"
"IBus-chewing 是新酷音輸入法的IBus前端。
新酷音輸入法是個智慧型注音輸入法，支援多種鍵盤布局，諸如：
標準注音鍵盤、IBM、精業、倚天、倚天26鍵、許氏、Dvorak、Dvorak許氏
及大千26鍵。

本輸入法也同時支援帶調漢語拼音輸入。")

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")

SET(AUTHORS "Peng Huang, Ding-Yi Chen")
SET(MAINTAINER "Ding-Yi Chen <dchen at redhat.com>")
SET(VENDOR "Red Hat, APAC, Inc.")
SET(LICENSE "GPLv2+")
SET(PRJ_GROUP "System Environment/Libraries")
SET(RPM_SPEC_URL "https://github.com/definite/${PROJECT_NAME}")
SET(RPM_SPEC_SOURCES "https://github.com/definite/%{name}/releases/download/%{version}/%{name}-%{version}-Source.tar.gz")

####################################################################
# Includes
#

# Use standard FHS if Fedora build is not enabled
IF(NOT CMAKE_FEDORA_ENABLE_FEDORA_BUILD)
    SET(LIBEXEC_DIR "${LIB_DIR}" CACHE PATH "LIBEXEC dir")
ENDIF(NOT CMAKE_FEDORA_ENABLE_FEDORA_BUILD)

INCLUDE(ManageEnvironment)
MANAGE_CMAKE_POLICY(CMP0017 NEW)

INCLUDE(ManageMessage)
INCLUDE(ManageVersion)
RELEASE_NOTES_READ_FILE()
INCLUDE(ManageArchive)
INCLUDE(ManageDependency)
INCLUDE(ManageFile)
INCLUDE(ManageSourceVersionControl)
INCLUDE(ManageTarget)
INCLUDE(ManageTranslation)
INCLUDE(ManageUninstall)

ENABLE_TESTING()

####################################################################
# Dependencies
#

# Enable GNOME_SHELL support by set the value to ON
SET(GNOME_SHELL ON CACHE BOOL "Enable GNOME Shell support")

# Enable GCONF2 support by set the value to ON
SET(GCONF2_SUPPORT OFF CACHE BOOL "Enable GConf2 support")

# Enable GSETTINGS support by set the value to ON
SET(GSETTINGS_SUPPORT ON CACHE BOOL "Enable GSettings support")

SET(IBUS_MIN_VER "1.3")
SET(CHEWING_MIN_VER "0.3.3")

########## Package Dependencies ##########

MANAGE_DEPENDENCY(BUILD_REQUIRES CMAKE VER "2.6.2" REQUIRED)

### ibus
MANAGE_DEPENDENCY(REQUIRES IBUS VER "${IBUS_MIN_VER}" REQUIRED PKG_CONFIG ${IBUS_PKG_CONFIG})

SET(IBUS_PKG_CONFIG "ibus-1.0" CACHE STRING "ibus pkg-config name")
MANAGE_DEPENDENCY(BUILD_REQUIRES IBUS VER "${IBUS_MIN_VER}" REQUIRED
    PKG_CONFIG ${IBUS_PKG_CONFIG} DEVEL
    )

### libchewing
SET(CHEWING_PACKAGE_NAME "libchewing" CACHE STRING "chewing package name")
MANAGE_DEPENDENCY(REQUIRES CHEWING VER "${CHEWING_MIN_VER}" REQUIRED
    PACKAGE_NAME "${CHEWING_PACKAGE_NAME}"
    )

SET(CHEWING_DEVEL_PACKAGE_NAME "${CHEWING_PACKAGE_NAME}-devel" CACHE STRING "chewing devel package name")
SET(CHEWING_PKG_CONFIG "chewing" CACHE STRING "chewing pkg-config name")
MANAGE_DEPENDENCY(BUILD_REQUIRES CHEWING VER "${CHEWING_MIN_VER}" REQUIRED
    PKG_CONFIG ${CHEWING_PKG_CONFIG}
    PACKAGE_NAME "${CHEWING_DEVEL_PACKAGE_NAME}"
    )

M_MSG(${M_INFO1} "CHEWING_VERSION=${CHEWING_VERSION}")
STRING_SPLIT(chewingVerList "." "${CHEWING_VERSION}")
LIST(GET chewingVerList 0 CHEWING_VERSION_MAJOR)
LIST(GET chewingVerList 1 CHEWING_VERSION_MINOR)
LIST(GET chewingVerList 2 CHEWING_VERSION_PATCH)
M_MSG(${M_INFO1} "CHEWING_VERSION_MAJOR=${CHEWING_VERSION_MAJOR}")
M_MSG(${M_INFO1} "CHEWING_VERSION_MINOR=${CHEWING_VERSION_MINOR}")
M_MSG(${M_INFO1} "CHEWING_VERSION_PATCH=${CHEWING_VERSION_PATCH}")
ADD_DEFINITIONS("-DCHEWING_VERSION_MAJOR=${CHEWING_VERSION_MAJOR}"
    "-DCHEWING_VERSION_MINOR=${CHEWING_VERSION_MINOR}"
    "-DCHEWING_VERSION_PATCH=${CHEWING_VERSION_PATCH}"
    )

## Find the correct chewin datadir
FOREACH(d ${CHEWING_CHEWING_DATADIR} ${CHEWING_LIBDIR}/libchewing  ${DATA_DIR}/chewing ${DATA_DIR}/libchewing)
    IF(EXISTS "${d}/symbols.dat")
	SET(CHEWING_DATADIR_REAL "${d}" CACHE STRING "CHEWING_DATADIR_REAL")
	BREAK()
    ENDIF()
ENDFOREACH()

IF("${CHEWING_DATADIR_REAL}" STREQUAL "")
    M_MSG(${M_ERROR} "Chewing: symbols.dat cannot be found, please reinstall chewing package")
ENDIF()

M_MSG(${M_INFO1} "CHEWING_DATADIR_REAL=${CHEWING_DATADIR_REAL}")
SET_COMPILE_ENV(CHEWING_DATADIR_REAL)

### Glib, Gtk and GOB
## Glib2 is not explicit list as Requires, as it should be pick up by rpm
SET(GLIB2_PKG_CONFIG "gio-2.0;glib-2.0;gmodule-2.0;gobject-2.0;gthread-2.0"
    CACHE STRING "glib2 pkg-config name")
MANAGE_DEPENDENCY(BUILD_REQUIRES GLIB2 REQUIRED
    PKG_CONFIG ${GLIB2_PKG_CONFIG} glib-2.0 DEVEL
    )

MANAGE_DEPENDENCY(REQUIRES GTK2  REQUIRED)
SET(GTK2_PKG_CONFIG "gtk+-2.0" CACHE STRING "gtk pkg-config name")
MANAGE_DEPENDENCY(BUILD_REQUIRES GTK2 REQUIRED
    PKG_CONFIG ${GTK2_PKG_CONFIG} DEVEL
    )

MANAGE_DEPENDENCY(BUILD_REQUIRES GOB2 VER "2.0.16" REQUIRED
    PROGRAM_NAMES "gob2"
    )

### X11
SET(X11_PKG_CONFIG "x11" CACHE STRING "x11 pkg-config name")
MANAGE_DEPENDENCY(BUILD_REQUIRES X11 REQUIRED
    PKG_CONFIG ${X11_PKG_CONFIG} PACKAGE_NAME "libX11-devel"
    )

####################################################################
# Building
#

#=== Compile flags
ADD_DEFINITIONS(-std=c99 -D_XOPEN_SOURCE)
IF(GSETTINGS_SUPPORT)
    ADD_DEFINITIONS(-DUSE_GSETTINGS)
ENDIF()
IF(GCONF2_SUPPORT)
    ADD_DEFINITIONS(-DUSE_GCONF2)
ENDIF()

## Directory that store ibus-chewing icons
SET_COMPILE_ENV(PRJ_ICON_DIR "${PRJ_DATA_DIR}/icons" CACHE STRING "PRJ_ICON_DIR")

#=== GSettings/GConf schemas
SET_COMPILE_ENV(PROJECT_SCHEMA_ID "org.freedesktop.IBus.Chewing" CACHE STRING "PROJECT_SCHEMA_ID")
SET_COMPILE_ENV(PROJECT_SCHEMA_BASE "/desktop/ibus/engine" CACHE STRING "PROJECT_SCHEMA_BASE")
SET_COMPILE_ENV(PROJECT_SCHEMA_SECTION "chewing" CACHE STRING "PROJECT_SCHEMA_SECTION")
SET_COMPILE_ENV(PROJECT_SCHEMA_DIR "${PROJECT_SCHEMA_BASE}/${PROJECT_SCHEMA_SECTION}" CACHE STRING "PROJECT_SCHEMA_DIR")
SET_COMPILE_ENV(PROJECT_GCONF2_SCHEMA_SECTION "Chewing" CACHE STRING "PROJECT_GCONF2_SCHEMA_SECTION")
SET_COMPILE_ENV(PROJECT_GCONF2_SCHEMA_DIR "${PROJECT_SCHEMA_BASE}/${PROJECT_GCONF2_SCHEMA_SECTION}"
    CACHE STRING "PROJECT_GCONF2_SCHEMA_DIR"
    )
SET_COMPILE_ENV(PROJECT_SCHEMA_PATH "${PROJECT_SCHEMA_DIR}/" CACHE STRING "PROJECT_SCHEMA_PATH")

#=== chewing.xml
SET(SYMBOL_XML "<symbol>&#x9177;</symbol>")
SET_COMPILE_ENV(CHEWING_HOTKEYS "Super+space")
SET(HOTKEYS_XML "<hotkeys>${CHEWING_HOTKEYS}</hotkeys>")
SET(SETUP_PROGRAM_XML "<setup>${LIBEXEC_DIR}/ibus-setup-chewing</setup>")

IF(IBUS_VERSION LESS 1.3.99)
    SET(SYMBOL_XML "<!-- ${SYMBOL_XML} -->")
    SET(HOTKEYS_XML "<!-- ${HOTKEYS_XML} -->")
    SET(SETUP_PROGRAM_XML "<!-- ${SETUP_PROGRAM_XML} -->")
ENDIF()

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/data/chewing.xml.in ${CMAKE_BINARY_DIR}/data/chewing.xml)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/data/ibus-setup-chewing.desktop.in ${CMAKE_BINARY_DIR}/data/ibus-setup-chewing.desktop)

#=== Sub directories
ADD_SUBDIRECTORY(po)
ADD_SUBDIRECTORY(src bin)
ADD_SUBDIRECTORY(test test-bin)

####################################################################
# Installing
#

INSTALL(FILES AUTHORS README.md ChangeLog COPYING USER-GUIDE
    DESTINATION "${PRJ_DOC_DIR}"
    )

INSTALL(FILES ${CMAKE_BINARY_DIR}/data/chewing.xml
    DESTINATION "${DATA_DIR}/ibus/component")

INSTALL(FILES ${CMAKE_BINARY_DIR}/data/ibus-setup-chewing.desktop
    DESTINATION "${DATA_DIR}/applications")

INSTALL(DIRECTORY icons
    DESTINATION "${PRJ_DATA_DIR}"
    )

MANAGE_SOURCE_VERSION_CONTROL_GIT()

####################################################################
# Packing
#
SET(SOURCE_ARCHIVE_DIR ${CMAKE_BINARY_DIR} CACHE PATH "Source Archive Dir")
PACK_SOURCE_ARCHIVE("${SOURCE_ARCHIVE_DIR}"
    GITIGNORE ${CMAKE_SOURCE_DIR}/.gitignore
    INCLUDE ${PROJECT_NAME}.pot
    )

INCLUDE(ManageRelease)

IF(CMAKE_FEDORA_ENABLE_FEDORA_BUILD)
    SET(RPM_BUILD_SOURCES ${SOURCE_ARCHIVE_DIR})
    ADD_SUBDIRECTORY(rpm)
    LIST(APPEND _releaset_targets "release_fedora")
ENDIF(CMAKE_FEDORA_ENABLE_FEDORA_BUILD)


#####################################################################
# Hosting
#

#INCLUDE(ManageUpload)
#ADD_CUSTOM_TARGET(upload
#    COMMENT "Uploading all files"
#    )

####################################################################
# Custom
#

####################################################################
# Release
#

INCLUDE(ManageRelease)
SET(releaseTarget "tag_push")
IF(CMAKE_FEDORA_ENABLE_FEDORA_BUILD)
    LIST(APPEND releaseTargets release_fedora)
ENDIF(CMAKE_FEDORA_ENABLE_FEDORA_BUILD)
MANAGE_RELEASE(${releaseTargets})

=== rpm/CMakeLists.txt ===
SET(RPM_BUILD_TOPDIR "${CMAKE_BINARY_DIR}/rpm" CACHE FILEPATH "RPM top dir")
SET(RPM_BUILD_SOURCES "${SOURCE_ARCHIVE_DIR}" CACHE FILEPATH "RPM Source dir")
SET(RPM_SPEC_CMAKE_FLAGS "-DCMAKE_FEDORA_ENABLE_FEDORA_BUILD=1  -DGSETTINGS_SUPPORT=%{gsettings_support} -DGCONF2_SUPPORT=%{gconf2_support}"
    CACHE STRING "CMake flags in RPM SPEC" FORCE
    )
INCLUDE(ManageRPM)
INCLUDE(ManageReleaseFedora)

#RPM_SPEC_STRING_ADD(RPM_SPEC_BUILD_OUTPUT "make VERBOSE=1 translations")

IF(NOT "${IBUS_VERSION}" VERSION_LESS "1.5.3")
    # IBus supports write cache since 1.5.3
    SET(RPM_SPEC_IBUS_WRITE_CACHE "[ -x %{_bindir}/ibus ] && %{_bindir}/ibus write-cache --system &>/dev/null || :")
    SET(RPM_SPEC_POST_COMMON "${RPM_SPEC_IBUS_WRITE_CACHE}")
    SET(RPM_SPEC_POSTUN_COMMON "${RPM_SPEC_IBUS_WRITE_CACHE}")
ELSE()
    SET(RPM_SPEC_POST_COMMON "")
    SET(RPM_SPEC_POSTUN_COMMON "")
ENDIF()


RPM_SPEC_STRING_ADD_DIRECTIVE(RPM_SPEC_SCRIPT_OUTPUT pre ""
    "%if \"%{gconf2_support}\" == \"ON\"
if [ \"$1\" -gt 1 ] ; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    [ -r %{_sysconfdir}/gconf/schemas/%{name}.schemas ] &&
    gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/%{name}.schemas >/dev/null || :

    # Upgrading 1.0.2.20090302-1.fc11 or older?
    [ -r %{_sysconfdir}/gconf/schemas/%{name}.schema ] &&
    gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/%{name}.schema >/dev/null || :
fi
%endif
    "
    )

RPM_SPEC_STRING_ADD_DIRECTIVE(RPM_SPEC_SCRIPT_OUTPUT preun ""
    "%if \"%{gconf2_support}\" == \"ON\"
if [ \"$1\" -eq 0 ] ; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/%{name}.schemas > /dev/null || :
fi
%endif
    "
    )


RPM_SPEC_STRING_ADD_DIRECTIVE(RPM_SPEC_SCRIPT_OUTPUT post ""
    "%if \"%{gsettings_support}\" == \"ON\"
/usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :
%endif

%if \"%{gconf2_support}\" == \"ON\"
if [ $1 -gt 1 ] ; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    [ -r %{_sysconfdir}/gconf/schemas/%{name}.schemas ] && gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/%{name}.schemas >/dev/null || :
fi
%endif

${RPM_SPEC_POST_COMMON}
    "
    )

RPM_SPEC_STRING_ADD_DIRECTIVE(RPM_SPEC_SCRIPT_OUTPUT postun ""
    "%if \"%{gsettings_support}\" == \"ON\"
/usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :
%endif 

%if \"%{gconf2_support}\" == \"ON\"
if [ $1 -gt 1 ] ; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    [ -r %{_sysconfdir}/gconf/schemas/%{name}.schemas ] &&
    gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/%{name}.schemas >/dev/null || :
fi
%endif

${RPM_SPEC_POSTUN_COMMON}
    "
    )

ADD_CUSTOM_COMMAND(OUTPUT ${SOURCE_ARCHIVE_FILE}
    COMMAND make pack_src
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )

PACK_RPM()
RELEASE_FEDORA(fedora)
# "Off" Warning is displayed if mock is not installed.
RPM_MOCK_BUILD()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 # Dependencies
 #
 
-SET(IBUS_CHEWING_DEPENDENCIES CHEWING GLIB2 GTK2 IBUS X11 XTST)
+SET(IBUS_CHEWING_DEPENDENCIES CHEWING GLIB2 GTK2 IBUS X11)
 
 IF(GCONF2_SUPPORT)
     # Schemas
@@ -57,9 +57,9 @@
 
 SET(GOB2_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}")
 MACRO(GOB_GENERATE name gobFile)
-    SET(GOB_GENERATED_C_${name} 
+    SET(GOB_GENERATED_C_${name}
 	${GOB2_OUTPUT_DIR}/${name}.c)
-    SET(GOB_GENERATED_${name} 
+    SET(GOB_GENERATED_${name}
 	${GOB_GENERATED_C_${name}}
 	"${GOB2_OUTPUT_DIR}/${name}.h"
 	"${GOB2_OUTPUT_DIR}/${name}-private.h"
@@ -67,29 +67,29 @@
 	)
 
     ADD_CUSTOM_COMMAND(OUTPUT ${GOB_GENERATED_${name}}
-	COMMAND ${GOB2_EXECUTABLE} "${gobFile}" 
+	COMMAND ${GOB2_EXECUTABLE} "${gobFile}"
 	-o "${GOB2_OUTPUT_DIR}/"
 	DEPENDS ${gobFile} ${ARGN}
 	)
 ENDMACRO(GOB_GENERATE name gobFile)
 
 
-GOB_GENERATE(ibus-chewing-engine 
+GOB_GENERATE(ibus-chewing-engine
     ${CMAKE_CURRENT_SOURCE_DIR}/IBusChewingEngine.gob
     ${IBUS_CHEWING_ENGINE_SOURCE_INCLUDED_C_FILES}
     )
-GOB_GENERATE(maker-dialog 
-    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialog.gob 
+GOB_GENERATE(maker-dialog
+    ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialog.gob
     )
 
 ADD_CUSTOM_TARGET(gob2
-    DEPENDS ${GOB_GENERATED_ibus-chewing-engine} 
+    DEPENDS ${GOB_GENERATED_ibus-chewing-engine}
     ${GOB_GENERATED_maker-dialog}
     COMMENT "Preprocess with gob2."
     )
 
 
-SET_SOURCE_FILES_PROPERTIES(${GOB_GENERATED_ibus-chewing-engine} 
+SET_SOURCE_FILES_PROPERTIES(${GOB_GENERATED_ibus-chewing-engine}
     ${GOB_GENERATED_maker-dialog} PROPERTIES GENERATED true
     )
 
@@ -126,14 +126,14 @@
 SET(BACKEND_SOURCE_FILES "")
 
 IF(GSETTINGS_SUPPORT)
-    LIST(APPEND BACKEND_SOURCE_FILES 
+    LIST(APPEND BACKEND_SOURCE_FILES
 	"${CMAKE_SOURCE_DIR}/src/GSettingsBackend.c"
 	"${CMAKE_SOURCE_DIR}/src/GSettingsBackend.h"
 	)
 ENDIF()
 
 IF(GCONF2_SUPPORT)
-    LIST(APPEND BACKEND_SOURCE_FILES 
+    LIST(APPEND BACKEND_SOURCE_FILES
 	"${CMAKE_SOURCE_DIR}/src/GConf2Backend.c"
 	"${CMAKE_SOURCE_DIR}/src/GConf2Backend.h"
 	)
@@ -162,11 +162,11 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/generate-gsettings-schemas.c
 	)
 
-    TARGET_LINK_LIBRARIES(generate-gsettings-schemas 
+    TARGET_LINK_LIBRARIES(generate-gsettings-schemas
 	${COMMON_LIBRARIES}
 	)
 
-    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_GSCHEMA_XML} 
+    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_GSCHEMA_XML}
 	DESTINATION "${GSETTINGS_SCHEMAS_DIR}"
 	)
 
@@ -211,7 +211,7 @@
 
     LIST(APPEND COMMON_LIBRARIES ${GCONF2_LIBRARIES})
 
-    TARGET_LINK_LIBRARIES(generate-gconf-schemas 
+    TARGET_LINK_LIBRARIES(generate-gconf-schemas
 	${COMMON_LIBRARIES} ${BACKEND_LIBRARIES}
 	)
 
@@ -242,7 +242,7 @@
 
 SET(GUI_CORE_SOURCE_FILES ${COMMON_SOURCE_FILES}
     ${BACKEND_SOURCE_FILES}
-    ${GOB_GENERATED_maker-dialog} 
+    ${GOB_GENERATED_maker-dialog}
     ${CMAKE_CURRENT_SOURCE_DIR}/IBusConfigBackend.c
     ${CMAKE_CURRENT_SOURCE_DIR}/IBusConfigBackend.h
     ${CMAKE_CURRENT_SOURCE_DIR}/MakerDialogWidget.c
@@ -252,14 +252,14 @@
 
 
 IF(GSETTINGS_SUPPORT)
-    LIST(APPEND GUI_CORE_SOURCE_FILES 
+    LIST(APPEND GUI_CORE_SOURCE_FILES
 	${CMAKE_CURRENT_SOURCE_DIR}/GSettingsBackend.c
 	${CMAKE_CURRENT_SOURCE_DIR}/GSettingsBackend.h
 	)
 ENDIF()
 
 IF(GCONF2_SUPPORT)
-    LIST(APPEND GUI_CORE_SOURCE_FILES 
+    LIST(APPEND GUI_CORE_SOURCE_FILES
 	${CMAKE_CURRENT_SOURCE_DIR}/GConf2Backend.c
 	${CMAKE_CURRENT_SOURCE_DIR}/GConf2Backend.h
 	)
@@ -282,10 +282,9 @@
     )
 
 ##== ibus-engine-chewing Start ==
-SET(IBUS_ENGINE_CHEWING_LIBRARIES ${COMMON_LIBRARIES} 
+SET(IBUS_ENGINE_CHEWING_LIBRARIES ${COMMON_LIBRARIES}
     ${GTK2_LIBRARIES}
     ${X11_LIBRARIES}
-    ${XTST_LIBRARIES} 
     CACHE INTERNAL "IBUS_ENGINE_CHEWING_LIBRARIES"
     )

=== test/CMakeLists.txt ===
#==================================================================
# Variable definition
#

##== Location of library include files
INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/bin
    )

IF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    ADD_DEFINITIONS("-DVERBOSE_LEVEL=DEBUG")
ELSE()
    ADD_DEFINITIONS("-DVERBOSE_LEVEL=MSG")
ENDIF()

ADD_DEFINITIONS("-DUNIT_TEST=1")

SET_SOURCE_FILES_PROPERTIES(${GOB_GENERATED_ibus-chewing-engine}
    ${GOB_GENERATED_maker-dialog} PROPERTIES GENERATED true
    )

#==================================================================
# Dependencies
#

FOREACH(_d ${IBUS_CHEWING_DEPENDENCIES})
    INCLUDE_DIRECTORIES(${${_d}_INCLUDE_DIRS})
    LINK_DIRECTORIES(${${_d}_LIBRARY_DIRS})
ENDFOREACH(_d ${IBUS_CHEWING_DEPENDENCIES})

## ADD_SOURCE_TEST(<testName> [NO_DEFAULT_SOURCE]
##     [SOURCES <src1> <src2...>]
##     [LIBRARIES <lib1> <lib2...>])
MACRO(ADD_SOURCE_TEST testName)
    SET(${testName}_LIBRARIES "")
    SET(${testName}_SOURCES "")
    SET(defaultSource 1)
    SET(mode "")
    FOREACH(arg ${ARGN})
        IF("${arg}" STREQUAL "LIBRARIES")
            SET(mode "${arg}")
        ELSEIF("${arg}" STREQUAL "SOURCES")
            SET(mode "${arg}")
        ELSEIF("${arg}" STREQUAL "NO_DEFAULT_SOURCE")
            SET(defaultSource 0)
            SET(mode "")
        ELSE()
            IF("${mode}" STREQUAL "LIBRARIES")
                LIST(APPEND ${testName}_LIBRARIES "${arg}")
            ELSEIF("${mode}" STREQUAL "SOURCES")
                LIST(APPEND ${testName}_SOURCES "${arg}")
            ENDIF()
        ENDIF()

        IF(defaultSource EQUAL 1)
            LIST(APPEND ${testName}_SOURCES
                "${CMAKE_SOURCE_DIR}/src/${testName}.c"
                )
        ENDIF()
    ENDFOREACH()

    ADD_EXECUTABLE(${testName}-test
        ${CMAKE_CURRENT_SOURCE_DIR}/${testName}-test.c
        ${${testName}_SOURCES}
        )

    TARGET_LINK_LIBRARIES(${testName}-test
        ${${testName}_LIBRARIES}
        ${GLIB2_LIBRARIES}
        )

    ADD_TEST("${testName}"
        gtester ${CMAKE_CURRENT_BINARY_DIR}/${testName}-test
        )

ENDMACRO(ADD_SOURCE_TEST testName)

#===========================================
#  Source File Tests
#

ADD_SOURCE_TEST(MakerDialogUtil
    SOURCES ${CMAKE_SOURCE_DIR}/src/MakerDialogUtil.c
    LIBRARIES ${GLIB2_LIBRARIES}
    )

ADD_SOURCE_TEST(MakerDialogBackend
    SOURCES ${COMMON_SOURCE_FILES} ${BACKEND_SOURCE_FILES}
    ${CMAKE_SOURCE_DIR}/src/MakerDialogProperty.c
    ${CMAKE_SOURCE_DIR}/src/MakerDialogUtil.c
    ${CMAKE_SOURCE_DIR}/src/MakerDialogUtil.h
    LIBRARIES ${COMMON_LIBRARIES} ${BACKEND_LIBRARIES}
    )

ADD_SOURCE_TEST(IBusChewingUtil
    SOURCES ${COMMON_SOURCE_FILES} ${BACKEND_SOURCE_FILES}
    ${CMAKE_SOURCE_DIR}/src/MakerDialogUtil.h
    ${CMAKE_SOURCE_DIR}/src/IBusChewingUtil.h
    LIBRARIES ${COMMON_LIBRARIES} ${BACKEND_LIBRARIES} ${IBUS_LIBRARIES} ${X11_LIBRARIES}
    )

ADD_SOURCE_TEST(IBusChewingPreEdit
    SOURCES ${COMMON_SOURCE_FILES} ${BACKEND_SOURCE_FILES}
    ${CMAKE_SOURCE_DIR}/src/IBusChewingUtil.c
    LIBRARIES ${COMMON_LIBRARIES} ${BACKEND_LIBRARIES} ${X11_LIBRARIES}
    )

ADD_SOURCE_TEST(ibus-chewing-engine NO_DEFAULT_SOURCE
    SOURCES ${GUI_CORE_SOURCE_FILES} ${GOB_GENERATED_ibus-chewing-engine}
    ${CMAKE_SOURCE_DIR}/src/IBusChewingLookupTable.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingLookupTable.h
    ${CMAKE_SOURCE_DIR}/src/IBusChewingPreEdit.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingPreEdit.h
    ${CMAKE_SOURCE_DIR}/src/IBusChewingSystray.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingSystray.h
    ${CMAKE_SOURCE_DIR}/src/IBusChewingUtil.c
    ${CMAKE_SOURCE_DIR}/src/IBusChewingUtil.h
    LIBRARIES ${IBUS_ENGINE_CHEWING_LIBRARIES} ${BACKEND_LIBRARIES}
    )

=== debian/changelog ===
ibus-chewing (1.6.1-2) unstable; urgency=medium

  * Team upload.

  [ Changwoo Ryu ]
  * Install executables in /usr/libexec instead of /usr/lib/ibus
    (Closes: #955228)

  [ Boyuan Yang ]
  * Rebuild before Ubuntu 22.04 release.
  * debian/watch: Update to v4 format and use correct GitHub watch grammar.
  * debian/rules: Drop unused dh_missing override and ddeb-migration.
  * debian/: Bump debhelper compat to v13.
  * debian/source/local-options: Dropped, useless.
  * debian/control: Bump Standards-Version to 4.6.0.

 -- Boyuan Yang <byang@debian.org>  Sat, 08 Jan 2022 18:51:23 -0500

ibus-chewing (1.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.3.0.
  * Bump compat to 12.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 05 Jan 2019 10:35:14 +0800

ibus-chewing (1.5.1-3) unstable; urgency=medium

  [ Jeremy Bicha ]
  * Drop obsolete Build-Depends on libgconf2-dev (Closes: #894319)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 27 May 2018 16:19:48 +0800

ibus-chewing (1.5.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.4.
    * Use https in Format in d/copyright.
  * Bump compat to 11.
  * Update Maintainer to new mailing list (Closes: #899544).
  * Update Vcs-* fields to salsa.debian.org.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 27 May 2018 16:16:06 +0800

=== debian/control ===
Source: ibus-chewing
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders: Asias He <asias.hejun@gmail.com>,
           Osamu Aoki <osamu@debian.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               cmake-fedora (>= 2.4.4+20151201),
               gob2 (>= 2.0.17),
               pkg-config,
               libchewing3-dev (>= 0.3.2-2~),
               libibus-1.0-dev (>= 1.3.99.20110419),
               libgtk2.0-dev,
               libx11-dev,
               libxtst-dev
Standards-Version: 4.6.0
Homepage: https://github.com/definite/ibus-chewing
Vcs-Git: https://salsa.debian.org/debian/ibus-chewing.git
Vcs-Browser: https://salsa.debian.org/debian/ibus-chewing

Package: ibus-chewing
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ibus (>= 1.5.22-2),
Description: Chewing engine for IBus
 IBus is an Intelligent Input Bus. It is a new input framework for Linux
 OS. It provides full featured and user friendly input method user interface.
 It also may help developers to develop input method easily.
 .
 IBus-chewing is a IBus based IM Engine for Traditional Chinese

=== debian/rules ===
#!/usr/bin/make -f
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =

CFLAGS+=$(CPPFLAGS)

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	-rm -r CMakeFiles NO_PACK Testing bin po/CMakeFiles $(CURDIR)/po/*.gmo $(CURDIR)/test-bin $(CURDIR)/po/CTestTestfile.cmake
	-cp $(CURDIR)/debian/bak/po/*.po $(CURDIR)/po/
	-cp $(CURDIR)/debian/bak/po/zanata.xml $(CURDIR)/po/
	-cp $(CURDIR)/debian/bak/ChangeLog $(CURDIR)/
	-cp $(CURDIR)/debian/bak/data/ibus-setup-chewing.desktop $(CURDIR)/data/


override_dh_auto_build:
	dh_auto_build
	make translations

# Kept manual invocation due to non-standard cmake target "translations".
override_dh_auto_configure:
	mkdir -p $(CURDIR)/debian/bak/po
	cp $(CURDIR)/po/*.po $(CURDIR)/debian/bak/po
	cp $(CURDIR)/po/zanata.xml $(CURDIR)/debian/bak/po
	cp $(CURDIR)/ChangeLog $(CURDIR)/debian/bak
	cmake -DCMAKE_INSTALL_PREFIX="/usr" \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DSYSCONF_INSTALL_DIR=/usr/share \
		-DCMAKE_MODULE_PATH=/usr/share/cmake/Modules \
		$(NULL)

override_dh_auto_install:
	cp $(CURDIR)/debian/bak/ChangeLog $(CURDIR)/
	dh_auto_install
	rm -f $(CURDIR)/debian/ibus-chewing/usr/share/doc/ibus-chewing/COPYING
	rm -f $(CURDIR)/debian/ibus-chewing/usr/share/doc/ibus-chewing/ChangeLog

override_dh_auto_test:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/definite/ibus-chewing/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## ibus-chewing 1.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -194,10 +194,10 @@
     PKG_CONFIG ${GLIB2_PKG_CONFIG} glib-2.0 DEVEL
     )
 
-MANAGE_DEPENDENCY(REQUIRES GTK2  REQUIRED)
-SET(GTK2_PKG_CONFIG "gtk+-2.0" CACHE STRING "gtk pkg-config name")
-MANAGE_DEPENDENCY(BUILD_REQUIRES GTK2 REQUIRED
-    PKG_CONFIG ${GTK2_PKG_CONFIG} DEVEL
+MANAGE_DEPENDENCY(REQUIRES GTK3  REQUIRED)
+SET(GTK3_PKG_CONFIG "gtk+-3.0" CACHE STRING "gtk pkg-config name")
+MANAGE_DEPENDENCY(BUILD_REQUIRES GTK3 REQUIRED
+    PKG_CONFIG ${GTK3_PKG_CONFIG} DEVEL
     )
 
 MANAGE_DEPENDENCY(BUILD_REQUIRES GOB2 VER "2.0.16" REQUIRED

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 # Dependencies
 #
 
-SET(IBUS_CHEWING_DEPENDENCIES CHEWING GLIB2 GTK2 IBUS X11)
+SET(IBUS_CHEWING_DEPENDENCIES CHEWING GLIB2 GTK3 IBUS X11)
 
 IF(GCONF2_SUPPORT)
     # Schemas
@@ -273,7 +273,7 @@
 
 TARGET_LINK_LIBRARIES(${IBUS_SETUP_CHEWING}
     ${COMMON_LIBRARIES}
-    ${GTK2_LIBRARIES}
+    ${GTK3_LIBRARIES}
     )
 
 MANAGE_FILE_INSTALL(TARGETS ${IBUS_SETUP_CHEWING} ARGS
@@ -283,7 +283,7 @@
 
 ##== ibus-engine-chewing Start ==
 SET(IBUS_ENGINE_CHEWING_LIBRARIES ${COMMON_LIBRARIES}
-    ${GTK2_LIBRARIES}
+    ${GTK3_LIBRARIES}
     ${X11_LIBRARIES}
     CACHE INTERNAL "IBUS_ENGINE_CHEWING_LIBRARIES"
     )

=== debian/changelog ===
ibus-chewing (1.6.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Update build-dependency to use GTK3.
  * debian/: Apply "wrap-and-sort -abst".

 -- Boyuan Yang <byang@debian.org>  Tue, 19 Dec 2023 10:39:44 -0500

ibus-chewing (1.6.1-3) UNRELEASED; urgency=medium

  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Debian Janitor <janitor@jelmer.uk>  Fri, 14 Oct 2022 21:56:58 -0000

=== debian/control ===
Source: ibus-chewing
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Asias He <asias.hejun@gmail.com>,
 Osamu Aoki <osamu@debian.org>,
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends:
 cmake,
 cmake-fedora (>= 2.4.4+20151201),
 debhelper-compat (= 13),
 gob2 (>= 2.0.17),
 libchewing3-dev (>= 0.3.2-2~),
 libgtk-3-dev,
 libibus-1.0-dev (>= 1.3.99.20110419),
 libx11-dev,
 libxtst-dev,
 pkg-config,
Standards-Version: 4.6.1
Homepage: https://github.com/definite/ibus-chewing
Vcs-Git: https://salsa.debian.org/debian/ibus-chewing.git
Vcs-Browser: https://salsa.debian.org/debian/ibus-chewing

Package: ibus-chewing
Architecture: any
Depends:
 ibus (>= 1.5.22-2),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Chewing engine for IBus
 IBus is an Intelligent Input Bus. It is a new input framework for Linux
 OS. It provides full featured and user friendly input method user interface.
 It also may help developers to develop input method easily.
 .
 IBus-chewing is a IBus based IM Engine for Traditional Chinese
